/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSCounter.h"

#include "Counter.h"
#include "URL.h"
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSCounterTableValues[] =
{
    { "identifier", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCounterIdentifier), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "listStyle", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCounterListStyle), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "separator", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCounterSeparator), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsCounterConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCounterTable = { 9, 7, true, JSCounterTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSCounterConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCounterConstructorTable = { 1, 0, false, JSCounterConstructorTableValues, 0 };
const ClassInfo JSCounterConstructor::s_info = { "CounterConstructor", &Base::s_info, &JSCounterConstructorTable, 0, CREATE_METHOD_TABLE(JSCounterConstructor) };

JSCounterConstructor::JSCounterConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSCounterConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSCounterPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSCounterConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSCounterConstructor, JSDOMWrapper>(exec, JSCounterConstructorTable, jsCast<JSCounterConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSCounterPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSCounterPrototypeTable = { 1, 0, false, JSCounterPrototypeTableValues, 0 };
const ClassInfo JSCounterPrototype::s_info = { "CounterPrototype", &Base::s_info, &JSCounterPrototypeTable, 0, CREATE_METHOD_TABLE(JSCounterPrototype) };

JSObject* JSCounterPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSCounter>(vm, globalObject);
}

const ClassInfo JSCounter::s_info = { "Counter", &Base::s_info, &JSCounterTable, 0 , CREATE_METHOD_TABLE(JSCounter) };

JSCounter::JSCounter(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<Counter> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSCounter::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSCounter::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSCounterPrototype::create(vm, globalObject, JSCounterPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSCounter::destroy(JSC::JSCell* cell)
{
    JSCounter* thisObject = static_cast<JSCounter*>(cell);
    thisObject->JSCounter::~JSCounter();
}

JSCounter::~JSCounter()
{
    releaseImplIfNotNull();
}

bool JSCounter::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSCounter* thisObject = jsCast<JSCounter*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSCounter, Base>(exec, JSCounterTable, thisObject, propertyName, slot);
}

EncodedJSValue jsCounterIdentifier(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSCounter* castedThis = jsDynamicCast<JSCounter*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    Counter& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.identifier());
    return JSValue::encode(result);
}


EncodedJSValue jsCounterListStyle(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSCounter* castedThis = jsDynamicCast<JSCounter*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    Counter& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.listStyle());
    return JSValue::encode(result);
}


EncodedJSValue jsCounterSeparator(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSCounter* castedThis = jsDynamicCast<JSCounter*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    Counter& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.separator());
    return JSValue::encode(result);
}


EncodedJSValue jsCounterConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSCounter* domObject = jsDynamicCast<JSCounter*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSCounter::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSCounter::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSCounterConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

bool JSCounterOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSCounterOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSCounter* jsCounter = jsCast<JSCounter*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsCounter->impl(), jsCounter);
    jsCounter->releaseImpl();
}

JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, Counter* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSCounter>(exec, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to Counter.
    COMPILE_ASSERT(!__is_polymorphic(Counter), Counter_is_polymorphic_but_idl_claims_not_to_be);
#endif
    ReportMemoryCost<Counter>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSCounter>(exec, globalObject, impl);
}

Counter* toCounter(JSC::JSValue value)
{
    return value.inherits(JSCounter::info()) ? &jsCast<JSCounter*>(value)->impl() : 0;
}

}
