/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSNotation.h"

#include "Notation.h"
#include "URL.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSNotationTableValues[] =
{
    { "publicId", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNotationPublicId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "systemId", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNotationSystemId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsNotationConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSNotationTable = { 9, 7, true, JSNotationTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSNotationConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSNotationConstructorTable = { 1, 0, false, JSNotationConstructorTableValues, 0 };
const ClassInfo JSNotationConstructor::s_info = { "NotationConstructor", &Base::s_info, &JSNotationConstructorTable, 0, CREATE_METHOD_TABLE(JSNotationConstructor) };

JSNotationConstructor::JSNotationConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSNotationConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSNotationPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSNotationConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSNotationConstructor, JSDOMWrapper>(exec, JSNotationConstructorTable, jsCast<JSNotationConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSNotationPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSNotationPrototypeTable = { 1, 0, false, JSNotationPrototypeTableValues, 0 };
const ClassInfo JSNotationPrototype::s_info = { "NotationPrototype", &Base::s_info, &JSNotationPrototypeTable, 0, CREATE_METHOD_TABLE(JSNotationPrototype) };

JSObject* JSNotationPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSNotation>(vm, globalObject);
}

const ClassInfo JSNotation::s_info = { "Notation", &Base::s_info, &JSNotationTable, 0 , CREATE_METHOD_TABLE(JSNotation) };

JSNotation::JSNotation(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<Notation> impl)
    : JSNode(structure, globalObject, impl)
{
}

void JSNotation::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSNotation::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSNotationPrototype::create(vm, globalObject, JSNotationPrototype::createStructure(vm, globalObject, JSNodePrototype::self(vm, globalObject)));
}

bool JSNotation::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSNotation* thisObject = jsCast<JSNotation*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSNotation, Base>(exec, JSNotationTable, thisObject, propertyName, slot);
}

EncodedJSValue jsNotationPublicId(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSNotation* castedThis = jsDynamicCast<JSNotation*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    Notation& impl = castedThis->impl();
    JSValue result = jsStringOrNull(exec, impl.publicId());
    return JSValue::encode(result);
}


EncodedJSValue jsNotationSystemId(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSNotation* castedThis = jsDynamicCast<JSNotation*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    Notation& impl = castedThis->impl();
    JSValue result = jsStringOrNull(exec, impl.systemId());
    return JSValue::encode(result);
}


EncodedJSValue jsNotationConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSNotation* domObject = jsDynamicCast<JSNotation*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSNotation::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSNotation::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSNotationConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}


}
