/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(WEBGL)

#include "JSOESTextureFloatLinear.h"

#include "OESTextureFloatLinear.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table for prototype */

static const HashTableValue JSOESTextureFloatLinearPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSOESTextureFloatLinearPrototypeTable = { 1, 0, false, JSOESTextureFloatLinearPrototypeTableValues, 0 };
const ClassInfo JSOESTextureFloatLinearPrototype::s_info = { "OESTextureFloatLinearPrototype", &Base::s_info, &JSOESTextureFloatLinearPrototypeTable, 0, CREATE_METHOD_TABLE(JSOESTextureFloatLinearPrototype) };

JSObject* JSOESTextureFloatLinearPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSOESTextureFloatLinear>(vm, globalObject);
}

const ClassInfo JSOESTextureFloatLinear::s_info = { "OESTextureFloatLinear", &Base::s_info, 0, 0 , CREATE_METHOD_TABLE(JSOESTextureFloatLinear) };

JSOESTextureFloatLinear::JSOESTextureFloatLinear(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<OESTextureFloatLinear> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSOESTextureFloatLinear::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSOESTextureFloatLinear::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSOESTextureFloatLinearPrototype::create(vm, globalObject, JSOESTextureFloatLinearPrototype::createStructure(vm, globalObject, globalObject->objectPrototype()));
}

void JSOESTextureFloatLinear::destroy(JSC::JSCell* cell)
{
    JSOESTextureFloatLinear* thisObject = static_cast<JSOESTextureFloatLinear*>(cell);
    thisObject->JSOESTextureFloatLinear::~JSOESTextureFloatLinear();
}

JSOESTextureFloatLinear::~JSOESTextureFloatLinear()
{
    releaseImplIfNotNull();
}

static inline bool isObservable(JSOESTextureFloatLinear* jsOESTextureFloatLinear)
{
    if (jsOESTextureFloatLinear->hasCustomProperties())
        return true;
    return false;
}

bool JSOESTextureFloatLinearOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    JSOESTextureFloatLinear* jsOESTextureFloatLinear = jsCast<JSOESTextureFloatLinear*>(handle.get().asCell());
    if (!isObservable(jsOESTextureFloatLinear))
        return false;
    WebGLRenderingContext* root = jsOESTextureFloatLinear->impl().context();
    return visitor.containsOpaqueRoot(root);
}

void JSOESTextureFloatLinearOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSOESTextureFloatLinear* jsOESTextureFloatLinear = jsCast<JSOESTextureFloatLinear*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsOESTextureFloatLinear->impl(), jsOESTextureFloatLinear);
    jsOESTextureFloatLinear->releaseImpl();
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7OESTextureFloatLinear@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore21OESTextureFloatLinearE[]; }
#endif
#endif
JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, OESTextureFloatLinear* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSOESTextureFloatLinear>(exec, impl))
        return result;

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7OESTextureFloatLinear@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore21OESTextureFloatLinearE[2];
#if COMPILER(CLANG)
    // If this fails OESTextureFloatLinear does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    COMPILE_ASSERT(__is_polymorphic(OESTextureFloatLinear), OESTextureFloatLinear_is_not_polymorphic);
#endif
#endif
    // If you hit this assertion you either have a use after free bug, or
    // OESTextureFloatLinear has subclasses. If OESTextureFloatLinear has subclasses that get passed
    // to toJS() we currently require OESTextureFloatLinear you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    ReportMemoryCost<OESTextureFloatLinear>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSOESTextureFloatLinear>(exec, globalObject, impl);
}

OESTextureFloatLinear* toOESTextureFloatLinear(JSC::JSValue value)
{
    return value.inherits(JSOESTextureFloatLinear::info()) ? &jsCast<JSOESTextureFloatLinear*>(value)->impl() : 0;
}

}

#endif // ENABLE(WEBGL)
